#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const program = require("commander");
const getLocalVersion_1 = require("../util/getLocalVersion");
require("../lib/error/exit");
program
    .version(getLocalVersion_1.localVersion)
    .usage('[command] [project] [options]')
    .command('server', '开启本地服务')
    .alias('s')
    .command('compile', '编译静态文件')
    .alias('c')
    .command('deploy', '部署静态文件')
    .alias('d')
    .command('format', '格式化文件')
    .alias('f')
    .command('init', '初始化一个项目')
    .alias('i')
    .on('--help', () => {
    console.log(`
                                        __
                                    _.-~  )   dop v${getLocalVersion_1.localVersion}
                        _..--~~~~,'   ,-/     _
                    .-'. . . .'   ,-','    ,' )
                    ,'. . . _   ,--~,-'__..-'  ,'
                ,'. . .  (@)' ---~~~~      ,'
                /. . . . '~~             ,-'
                /. . . . .             ,-'
            ; . . . .  - .        ,'
            : . . . .       _     /
            . . . . .          \`-.:
            . . . ./  - .          )
        .  . . |  _____..---.._/ ____ ~~~ _
     ~---~~~~----~~~~             ~~
`);
})
    .parse(process.argv);
