"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dophin_core_1 = require("dophin-core");
const log_1 = require("../../util/log");
class CompilerClass extends dophin_core_1.DophinBaseClass {
    constructor(entry, type, getString, singleFile) {
        super({ entry, type, getString, singleFile });
        this.webpackConfig = {};
    }
    dophinInited() {
        const { allProjects, rootPath } = this.runtime;
        const { entry } = this.params;
        const project = global.__PROJECT__;
        if (!project) {
            log_1.default.error('CompilerClass 未定义子项目名称');
            return false;
        }
        if (Array.isArray(allProjects) && !allProjects.includes(project) && (!entry || entry.indexOf('.') === -1)) {
            log_1.default.error(`${rootPath} 下找不到子项目 ${project}`);
            return false;
        }
    }
}
exports.default = CompilerClass;
