"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const result_1 = require("../../result");
class RecordModules {
    constructor(options = {}) {
        this.options = {};
        Object.assign(this.options, options);
    }
    apply(compiler) {
        const { rootDir = '' } = this.options;
        compiler.plugin('done', function (stats) {
            const _stats = stats.toJson();
            const chunks = _stats.chunks;
            const result = {};
            for (const chunk of chunks) {
                const _moduleKey = path.join(rootDir, `project/${global.__PROJECT__}/build/js`, chunk.files[0]);
                result[_moduleKey] = [];
                const modules = chunk.modules;
                for (const _module of modules) {
                    result[_moduleKey].push(path.join(rootDir, _module.name));
                }
            }
            result_1.jsModules.set(result);
        });
    }
}
exports.default = RecordModules;
