"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const presetsEnv = require("babel-preset-env");
const presetsReact = require("babel-preset-react");
const runtime = require("babel-plugin-transform-runtime");
const dynamicImport = require("babel-plugin-syntax-dynamic-import");
const dophin_core_1 = require("dophin-core");
let __cache;
exports.getBabelConfig = (rootConfig) => {
    const dophinRuntimePath = path.resolve(__dirname, '../../../node_modules/babel-runtime');
    if (__cache) {
        return __cache;
    }
    __cache = {
        presets: [
            [
                presetsEnv,
                {
                    useBuiltIns: 'usage',
                    targets: {
                        browsers: (rootConfig && rootConfig.browsers) ||
                            dophin_core_1.constants.browsers,
                    },
                },
            ],
            [presetsReact],
        ],
        plugins: [
            [
                runtime,
                {
                    moduleName: dophinRuntimePath,
                },
            ],
            [
                dynamicImport,
            ],
        ],
    };
    return __cache;
};
