"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const UglifyJS = require("uglify-js");
const mkdirs_1 = require("../../../../util/mkdirs");
const dophin_core_1 = require("dophin-core");
const { log } = dophin_core_1.utils;
const jsConcat = (target, source) => __awaiter(void 0, void 0, void 0, function* () {
    const isProductionEnv = process.env.NODE_ENV === 'production' ? true : false;
    let resultString = '';
    log.debug(`开始合并js文件: ${path.basename(target)}`);
    try {
        source.forEach((filePath) => {
            if (!fs.existsSync(filePath)) {
                return;
            }
            const codes = fs.readFileSync(filePath, { encoding: 'utf8' });
            if (isProductionEnv) {
                resultString += UglifyJS.minify(codes).code;
            }
            else {
                resultString += `/* source: ${filePath} */\n${codes}\n\n`;
            }
        });
    }
    catch (error) {
        return error;
    }
    mkdirs_1.default(path.dirname(target));
    fs.writeFileSync(target, resultString, 'utf8');
    return resultString;
});
exports.default = jsConcat;
