"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const scss_1 = require("../compile/scss");
const js_1 = require("../compile/js");
const compileLab_1 = require("../compile/js/compileLab");
const css_1 = require("../compile/css");
const vm_1 = require("../compile/vm");
const images_1 = require("../compile/images");
const compile = (projectConfig, config) => {
    const compileTasks = [];
    config && config.CONFIG.type.forEach((type) => {
        switch (type) {
            case 'js':
                compileTasks.push(js_1.default('', 'compile').run());
                compileTasks.push(compileLab_1.default('compile').run());
                break;
            case 'css':
                compileTasks.push(css_1.default('', 'compile').run());
                if (projectConfig.sass) {
                    compileTasks.push(scss_1.default('', 'compile').run());
                }
                break;
            case 'images':
                compileTasks.push(images_1.default('compile').run());
                break;
            case 'vm':
                compileTasks.push(vm_1.default('compile').run());
                break;
            default:
                break;
        }
    });
    return Promise.all(compileTasks);
};
exports.default = compile;
