"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const rimraf = require("rimraf");
const JsHandle_1 = require("./tasks/JsHandle");
const readDir_1 = require("../../../util/readDir");
const log_1 = require("../../../util/log");
const preCompile = (rootConfig, config) => {
    const project = global.__PROJECT__;
    const outDir = rootConfig && rootConfig.dist.src.replace('{project}', project) || '';
    const promise = new Promise((resolve, reject) => {
        log_1.default.debug(`开始清理${outDir}`);
        rimraf(outDir, (err) => {
            if (err) {
                reject(err);
                return;
            }
            if (config && typeof config.jsHandle === 'function') {
                log_1.default.debug('进行 jsHandle 预处理');
                const files = readDir_1.default(path.resolve(config.source, 'js'));
                const promises = files.map((file) => {
                    return JsHandle_1.default(file.path, config.jsHandle);
                });
                resolve(Promise.all(promises));
            }
            else {
                resolve();
            }
        });
    });
    return promise;
};
exports.default = preCompile;
