"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const jsHandle = (file, handle) => {
    const promise = new Promise((resolve, reject) => {
        const fileBasename = path.basename(file);
        fs.readFile(file, 'utf8', (err, data) => {
            if (err) {
                reject(err);
                return;
            }
            const newData = handle && handle(data) || data;
            if (newData) {
                fs.writeFile(file, newData, 'utf8', (_err) => {
                    if (_err) {
                        reject(_err);
                        return;
                    }
                    resolve();
                });
            }
        });
    });
    return promise;
};
exports.default = jsHandle;
