"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const log_1 = require("../../util/log");
const getRemoteVersion_1 = require("../../util/getRemoteVersion");
const getLocalVersion_1 = require("../../util/getLocalVersion");
process.on('exit', (code) => {
    const latestVersion = getRemoteVersion_1.default();
    try {
        if (latestVersion.trim() > getLocalVersion_1.localVersion.trim()) {
            log_1.default.success(`[dophin更新] 检测到新版本 ${latestVersion.trim()}，您当前版本 ${getLocalVersion_1.localVersion}`);
        }
    }
    catch (error) {
        log_1.default.debug(error.message);
    }
    switch (code) {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        case 3:
            log_1.default.exit(code, `当前项目没有找到配置文件: do.config.js`);
            break;
        case 4:
            break;
        default:
            log_1.default.exit(code, `error: ${code} `);
            break;
    }
});
