"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const download = require("download-git-repo");
const dophin_core_1 = require("dophin-core");
const log_1 = require("../../util/log");
const initProject = (project) => {
    const successLog = () => {
        log_1.default.success(`项目 ${project} 创建成功`);
    };
    const dest = path.resolve(process.cwd(), project);
    if (fs.existsSync(dest)) {
        log_1.default.error(`当前目录下已存在 ${project} 目录`);
        return;
    }
    download(dophin_core_1.constants.defaulteTemplateRepo[0], dest, (err) => {
        if (err) {
            download(dophin_core_1.constants.defaulteTemplateRepo[1], dest, { clone: true }, (_err) => {
                if (_err) {
                    log_1.default.error(`项目 ${project} 创建失败, 联系管理员吧: ${err.message.trim()}`);
                }
                else {
                    successLog();
                }
            });
        }
        else {
            successLog();
        }
    });
};
exports.default = initProject;
