"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const express = require("express");
const log_1 = require("../../util/log");
const initRoutes = (rootPath) => {
    const router = express.Router();
    router.get('/(([a-zA-Z0-9-]+/)+)?:pageName/:dataName', (req, res, next) => {
        const rootDir = rootPath + '';
        let projectName, dataPath = '', filePath = '', childProjectName = '', configPath = '';
        const pageName = req.params.pageName, dataName = req.params.dataName, _path = req.path;
        if (dataName.indexOf('.') !== -1 || pageName === 'data' || pageName === 'mock') {
            next();
            return;
        }
        log_1.default.debug(`请求路径 ${_path}`);
        const paths = _path.split('/'), len = paths.length;
        let _filePathStartIndex = 2;
        projectName = paths[1];
        log_1.default.debug(`项目名称 ${projectName}`);
        let projectConfig = {};
        const projectPath = path.resolve(rootDir, 'project/', projectName), projectConfigPath = path.resolve(projectPath, 'config.js');
        if (fs.existsSync(projectConfigPath)) {
            projectConfig = require(projectConfigPath);
        }
        const _childProjects = projectConfig.childProjects;
        if (_childProjects && Array.isArray(_childProjects)) {
            _filePathStartIndex = 3;
            if (_childProjects.indexOf(paths[2]) >= 0) {
                dataPath = `data/${projectName}/${paths[2]}/${dataName}.json`;
                configPath = `data/${projectName}/${paths[2]}/config/${pageName}.json`;
                childProjectName = `/${paths[2]}`;
            }
        }
        else {
            dataPath = `data/${projectName}/${dataName}.json`;
            configPath = `data/${projectName}/config/${pageName}.json`;
        }
        for (let i = _filePathStartIndex; i < len; i++) {
            if (i < len - 1 && i > 0) {
                filePath += '/' + paths[i];
            }
        }
        let objData = {}, configData = {}, initModel = {};
        dataPath = path.resolve(rootDir, dataPath);
        configPath = path.resolve(rootDir, configPath);
        if (fs.existsSync(dataPath)) {
            try {
                const _data = fs.readFileSync(path.resolve(rootDir, dataPath), 'utf8');
                objData = Object.assign(JSON.parse(_data.toString()));
            }
            catch (error) {
                log_1.default.error(error);
            }
        }
        else {
            log_1.default.error(`${dataPath} 不存在`);
        }
        if (fs.existsSync(configPath)) {
            try {
                const _configBit = fs.readFileSync(path.resolve(rootDir, configPath), 'utf8');
                configData = Object.assign(configData, JSON.parse(_configBit.toString()));
            }
            catch (error) {
                log_1.default.error(error);
            }
        }
        else {
            log_1.default.warn(`${configPath} 不存在`);
        }
        initModel = Object.assign(objData, configData);
        projectConfig.initModelHandle && projectConfig.initModelHandle(initModel);
        Object.assign(initModel, {
            __VMOPTIONS__: {
                childProjectName,
                projectConfig,
            },
        });
        let templateType = 'vm';
        if (global.__EJS__ === true) {
            templateType = 'ejs';
        }
        log_1.default.debug(`渲染vm文件: ${projectName}/build/WEB-INF${childProjectName}${filePath}.${templateType}`);
        res.render(projectName + '/build/WEB-INF' + childProjectName + filePath + '.' + templateType, initModel);
    });
    return router;
};
exports.default = initRoutes;
