"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const url = require("url");
const mime = require("mime");
const mapStatic = (project, rootPath) => {
    const mock = (req, res, next) => {
        const fileUrlPath = url.parse(req.originalUrl).pathname + '';
        const filePath = path.resolve(rootPath, `project/${project}/build${fileUrlPath}`);
        if (fs.existsSync(filePath)) {
            res.writeHead(200, {
                'Access-Control-Allow-Origin': '*',
                'Content-Type': mime.getType(filePath) || '',
                'Cache-Control': 'max-age=0',
                'Server': 'dophin',
                'X-Powered-By': 'dophin',
            });
            res.end(fs.readFileSync(filePath));
        }
        else {
            next();
        }
    };
    return mock;
};
exports.default = mapStatic;
