"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const url = require("url");
const mockMiddleware = (rootPath) => {
    const mock = (req, res, next) => {
        let dataPath = path.resolve(rootPath, `.${url.parse(req.originalUrl).pathname}`);
        if (!dataPath.includes('.json')) {
            dataPath += '.json';
        }
        if (fs.existsSync(dataPath)) {
            res.writeHead(200, {
                'Access-Control-Allow-Origin': '*',
                'Content-Type': 'application/json;charset=utf-8',
                'Cache-Control': 'max-age=0',
                'Server': 'dophin',
                'X-Powered-By': 'dophin',
            });
            res.end(fs.readFileSync(dataPath));
        }
        else {
            next();
        }
    };
    return mock;
};
exports.default = mockMiddleware;
