#!/usr/bin/env node
"use strict";
exports.__esModule = true;
var program = require("commander");
var getLocalVersion_1 = require("../util/getLocalVersion");
require("../lib/error/exit");
program
    .version(getLocalVersion_1.localVersion)
    .usage('[command] [project] [options]')
    .command('server', '开启本地服务')
    .alias('s')
    .command('compile', '编译静态文件')
    .alias('c')
    .command('deploy', '部署静态文件')
    .alias('d')
    .command('format', '格式化文件')
    .alias('f')
    .command('init', '初始化一个项目')
    .alias('i')
    .on('--help', function () {
    console.log("\n                                        __\n                                    _.-~  )   dop v" + getLocalVersion_1.localVersion + "\n                        _..--~~~~,'   ,-/     _\n                    .-'. . . .'   ,-','    ,' )\n                    ,'. . . _   ,--~,-'__..-'  ,'\n                ,'. . .  (@)' ---~~~~      ,'\n                /. . . . '~~             ,-'\n                /. . . . .             ,-'\n            ; . . . .  - .        ,'\n            : . . . .       _     /\n            . . . . .          `-.:\n            . . . ./  - .          )\n        .  . . |  _____..---.._/ ____ ~~~ _\n     ~---~~~~----~~~~             ~~\n");
})
    .parse(process.argv);
