"use strict";
/**
 * webpack的plugin，用于记录文件树结构内容
 */
exports.__esModule = true;
var path = require("path");
var result_1 = require("../../result");
var RecordModules = /** @class */ (function () {
    function RecordModules(options) {
        if (options === void 0) { options = {}; }
        // 插件传参
        this.options = {};
        Object.assign(this.options, options);
    }
    RecordModules.prototype.apply = function (compiler) {
        var _a = this.options.rootDir, rootDir = _a === void 0 ? '' : _a;
        compiler.plugin('done', function (stats) {
            var _stats = stats.toJson();
            var chunks = _stats.chunks;
            var result = {};
            for (var _i = 0, chunks_1 = chunks; _i < chunks_1.length; _i++) {
                var chunk = chunks_1[_i];
                var _moduleKey = path.join(rootDir, "project/" + global.__PROJECT__ + "/build/js", chunk.files[0]);
                result[_moduleKey] = [];
                var modules = chunk.modules;
                for (var _a = 0, modules_1 = modules; _a < modules_1.length; _a++) {
                    var _module = modules_1[_a];
                    result[_moduleKey].push(path.join(rootDir, _module.name));
                }
            }
            result_1.jsModules.set(result);
        });
    };
    return RecordModules;
}());
exports["default"] = RecordModules;
