"use strict";
/**
 * 编译css
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var fs = require("fs");
var path = require("path");
var rimraf = require("rimraf");
var postcss = require("postcss");
var getPostcssPlugins_1 = require("../dependencies/getPostcssPlugins");
var CompileBaseClass_1 = require("../CompileBaseClass");
var readDir_1 = require("../../../util/readDir");
var mkdirs_1 = require("../../../util/mkdirs");
var watch_1 = require("../../../util/watch");
var dophin_core_1 = require("dophin-core");
var log = dophin_core_1.utils.log, debounce = dophin_core_1.utils.debounce;
var CssCompiler = /** @class */ (function (_super) {
    __extends(CssCompiler, _super);
    function CssCompiler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CssCompiler.prototype.taskRunning = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var that, _a, rootPath, rootConfig, _b, projectConfig, _c, entry, type, getString, singleFile, project, outDir, entryDir, entryFiles, handleCss, asyncCompile, calEntryFiles, watchTask, compilePromise;
            return __generator(this, function (_d) {
                that = this;
                _a = that.runtime, rootPath = _a.rootPath, rootConfig = _a.rootConfig, _b = _a.projectConfig, projectConfig = _b === void 0 ? {} : _b;
                _c = that.params, entry = _c.entry, type = _c.type, getString = _c.getString, singleFile = _c.singleFile;
                project = global.__PROJECT__;
                if (type === undefined) {
                    type = entry;
                }
                outDir = rootConfig && rootConfig.dist.css.replace('{project}', project) || '';
                entryDir = rootConfig && rootConfig.src.css.replace('{project}', project) || '';
                entryFiles = [];
                if (!fs.existsSync(entryDir) && !singleFile) {
                    return [2 /*return*/];
                }
                handleCss = function (file) {
                    // 获取postcss的plugin
                    var postcssPlugins = getPostcssPlugins_1["default"]({ rootPath: rootPath, rootConfig: rootConfig, projectConfig: projectConfig }, file);
                    var promise = new Promise(function (resolve, reject) {
                        log.debug("\u5F00\u59CB\u6253\u5305 " + path.basename(file));
                        fs.readFile(file, { encoding: 'utf8' }, function (err, css) {
                            if (err) {
                                reject(err);
                                return;
                            }
                            var outPath = '';
                            if (singleFile) {
                                outPath = singleFile.dest;
                            }
                            else {
                                var _dir = path.relative(entryDir, file);
                                outPath = path.resolve(outDir, _dir);
                            }
                            mkdirs_1["default"](path.dirname(outPath));
                            postcss(postcssPlugins).process(css, {
                                from: file,
                                to: outPath
                            }).then(function (result) {
                                if (!getString) {
                                    fs.writeFileSync(outPath, result.css, 'utf8');
                                }
                                resolve(result.css);
                            })["catch"](function (error) {
                                reject(error);
                            });
                        });
                    });
                    return promise;
                };
                asyncCompile = function (_entryFiles) {
                    // 将所有文件处理封装成promise, 并发处理所有文件
                    var promises = _entryFiles.map(function (file) {
                        return handleCss(file);
                    });
                    return Promise.all(promises);
                };
                calEntryFiles = function () {
                    entryFiles = [];
                    var files = readDir_1["default"](entryDir);
                    files.forEach(function (file) {
                        if (file.name.indexOf('_') !== 0 && file.name.indexOf('.') !== 0) {
                            entryFiles.push(file.path);
                        }
                    });
                };
                if (entry) {
                    entryFiles.push(entry);
                }
                else {
                    calEntryFiles();
                }
                watchTask = function () {
                    // 监听项目目录所有文件修改
                    watch_1["default"]({ directories: [entryDir] }, function (filePath, mtime) {
                        if (filePath && path.basename(filePath).indexOf('.') !== 0) {
                            log.info(filePath + " \u6709\u6539\u52A8, \u5F00\u59CB\u7F16\u8BD1\u5E76\u6253\u5305\u5230 build \u76EE\u5F55");
                            calEntryFiles();
                            asyncCompile(entryFiles).then(function () {
                                log.success('css打包完成');
                            })["catch"](function (_err) {
                                log.error(_err);
                            });
                        }
                    });
                };
                compilePromise = function () {
                    return new Promise(function (resolve, reject) {
                        if (entry) {
                            resolve(asyncCompile(entryFiles));
                        }
                        else {
                            log.debug("\u5F00\u59CB\u6E05\u7406" + outDir);
                            rimraf(outDir, function (err) {
                                if (err) {
                                    reject(err);
                                    return;
                                }
                                resolve(asyncCompile(entryFiles));
                            });
                        }
                    });
                };
                switch (type) {
                    case 'watch':
                        watchTask();
                        break;
                    case 'compile':
                        return [2 /*return*/, compilePromise()];
                    case 'watchAndCompile':
                        asyncCompile(entryFiles).then(function () {
                            log.success('css打包完成');
                        })["catch"](function (_err) {
                            log.error(_err);
                        });
                        watchTask();
                    default:
                        break;
                }
                return [2 /*return*/];
            });
        });
    };
    CssCompiler.prototype.afterTaskRun = function () {
        var _a = this.params.entry, entry = _a === void 0 ? '' : _a;
        // 将运行结果记录到result
        if (entry.indexOf('.') !== -1) {
            this.result = this.runtime.taskRunning[0];
        }
        else {
            this.result = this.runtime.taskRunning;
        }
    };
    return CssCompiler;
}(CompileBaseClass_1["default"]));
var wrapper = function (entry, type, getString, singleFile) {
    return new CssCompiler(entry, type, getString, singleFile);
};
exports["default"] = wrapper;
