"use strict";
/**
 * 获取babel配置
 */
exports.__esModule = true;
var path = require("path");
var presetsEnv = require("babel-preset-env");
var presetsReact = require("babel-preset-react");
var runtime = require("babel-plugin-transform-runtime");
// 获取项目配置
var dophin_core_1 = require("dophin-core");
var __cache;
exports.getBabelConfig = function (rootConfig) {
    var dophinRuntimePath = path.resolve(__dirname, '../../../node_modules/babel-runtime');
    if (__cache) {
        return __cache;
    }
    __cache = {
        presets: [
            [
                presetsEnv,
                {
                    useBuiltIns: 'usage',
                    targets: {
                        browsers: (rootConfig && rootConfig.browsers) ||
                            dophin_core_1.constants.browsers
                    }
                },
            ],
            [presetsReact],
        ],
        plugins: [
            [
                runtime,
                {
                    moduleName: dophinRuntimePath
                },
            ],
        ]
    };
    return __cache;
};
