"use strict";
/**
 *  在所有插件之前运行, 用来获取项目以及子项目配置信息
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var fs = require("fs");
var path = require("path");
var webpack = require("webpack");
var extend = require("extend");
var ExtractTextPlugin = require("extract-text-webpack-plugin");
// 打包css方法
var css_1 = require("../css");
var scss_1 = require("../scss");
// webpack ConcatCss plugin
var concatCss_1 = require("../compileTool/plugins/concatCss");
// webpack 记录文件结构plugin
var recordModules_1 = require("../compileTool/plugins/recordModules");
var log_1 = require("../../../util/log");
// 获取webpack默认配置的方法
var getWebpackConfig_1 = require("./getWebpackConfig");
var configCache;
var initCompileConfig = function (_a) {
    var rootConfig = _a.rootConfig, rootPath = _a.rootPath, projectConfig = _a.projectConfig;
    return __awaiter(_this, void 0, void 0, function () {
        var rootDir, webpackDefaultConfig, webpackPlugins, webpackRules, _b, _c, extractedCssName, sourceFile, output, baseCss, config;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    // 先走缓存
                    if (configCache) {
                        return [2 /*return*/, configCache];
                    }
                    rootDir = rootPath + '';
                    webpackDefaultConfig = getWebpackConfig_1["default"]({ rootConfig: rootConfig, rootPath: rootPath, projectConfig: projectConfig });
                    webpackPlugins = webpackDefaultConfig.plugins || [];
                    webpackRules = webpackDefaultConfig.module.rules || [];
                    // 处理webpack配置中的一些脏配置
                    if (projectConfig.webpack && projectConfig.webpack.need) {
                        delete projectConfig.webpack.need;
                    }
                    // 配置react相关开发配置
                    if (projectConfig.react) {
                        try {
                            if (typeof projectConfig.react.manifest === 'string') {
                                projectConfig.react.manifest = [projectConfig.react.manifest];
                            }
                            projectConfig.react.manifest.forEach(function (manifest) {
                                var _manfestFile = path.resolve(rootDir, manifest);
                                if (fs.existsSync(_manfestFile)) {
                                    webpackPlugins.push(new webpack.DllReferencePlugin({
                                        context: rootDir,
                                        manifest: require(_manfestFile)
                                    }));
                                }
                            });
                        }
                        catch (error) {
                            log_1["default"].error(error);
                        }
                    }
                    // 添加webpack的loader
                    if (projectConfig.webpack && projectConfig.webpack.loader) {
                        Array.isArray(projectConfig.webpack.loader) && projectConfig.webpack.loader.forEach(function (_loader) {
                            // dophin定义的配置规则
                            if (_loader.loaderName !== '' && _loader.loaderName !== null && typeof _loader.loaderName !== 'undefined') {
                                // 自带loader
                                webpackRules.push({
                                    test: _loader.test,
                                    use: [
                                        {
                                            loader: path.resolve(__dirname, "../../../", "lib/compile/compileTool/loader/" + _loader.loaderName + ".js"),
                                            options: _loader.options || ''
                                        },
                                    ],
                                    exclude: _loader.exclude || /node_modules/
                                });
                            }
                            else {
                                // 传入loader
                                webpackRules.push(_loader);
                            }
                        });
                        delete projectConfig.webpack.loader;
                    }
                    // 添加webpack插件
                    if (projectConfig.webpack && projectConfig.webpack.pluginConfig) {
                        Array.isArray(projectConfig.webpack.pluginConfig) && projectConfig.webpack.pluginConfig.forEach(function (_plugin) {
                            // dophin定义的配置规则
                            if (Array.isArray(_plugin)) {
                                var pluginName = _plugin[0], pluginConfig = _plugin[1];
                                var plugin = eval(pluginName);
                                webpackPlugins.push(new plugin(pluginConfig));
                            }
                            // 直接传一个function，支持第三方插件
                            if (typeof _plugin === 'function') {
                                webpackPlugins.push(_plugin);
                            }
                        });
                        delete projectConfig.webpack.pluginConfig;
                    }
                    if (!projectConfig.extractCss) return [3 /*break*/, 5];
                    _b = projectConfig.extractCss, _c = _b.extractedCssName, extractedCssName = _c === void 0 ? '../css/extract.css' : _c, sourceFile = _b.sourceFile, output = _b.output;
                    // css extract插件 抽离css
                    webpackPlugins.push(new ExtractTextPlugin({
                        allChunks: true,
                        filename: extractedCssName
                    }));
                    baseCss = '';
                    if (!/\.scss/.test(sourceFile)) return [3 /*break*/, 2];
                    return [4 /*yield*/, scss_1["default"](sourceFile, 'compile', true).run()];
                case 1:
                    baseCss = _d.sent();
                    return [3 /*break*/, 4];
                case 2:
                    if (!/\.css/.test(sourceFile)) return [3 /*break*/, 4];
                    return [4 /*yield*/, css_1["default"](sourceFile, 'compile', true).run()];
                case 3:
                    baseCss = _d.sent();
                    _d.label = 4;
                case 4:
                    // 将抽取出来的css与已有css文件合并后输出到output
                    sourceFile && output && webpackPlugins.push(new concatCss_1["default"]({
                        baseCss: baseCss,
                        entryName: extractedCssName,
                        output: output
                    }));
                    _d.label = 5;
                case 5:
                    // 记录文件结构
                    webpackPlugins.push(new recordModules_1["default"]({ rootDir: rootDir }));
                    config = extend(true, {
                        // 项目webpack配置
                        webpack: extend(true, webpackDefaultConfig, projectConfig.webpack)
                    }, projectConfig);
                    configCache = config;
                    return [2 /*return*/, config];
            }
        });
    });
};
exports["default"] = initCompileConfig;
