"use strict";
exports.__esModule = true;
// 初始化项目配置
var scss_1 = require("./scss");
var js_1 = require("./js");
var compileLab_1 = require("./js/compileLab");
var css_1 = require("./css");
var vm_1 = require("./vm");
var images_1 = require("./images");
var dophin_core_1 = require("dophin-core");
var log = dophin_core_1.utils.log;
var run = function (type) {
    if (type === void 0) { type = ''; }
    switch (type.toLocaleLowerCase()) {
        case 'watchall':
            js_1["default"]('', 'watch').run();
            compileLab_1["default"]('watch').run();
            css_1["default"]('', 'watch').run();
            scss_1["default"]('', 'watch').run();
            vm_1["default"]('watch').run();
            images_1["default"]('watch').run();
            break;
        case 'all':
            Promise.all([
                js_1["default"]('', 'compile').run(),
                compileLab_1["default"]('compile').run(),
                css_1["default"]('', 'compile').run(),
                scss_1["default"]('', 'compile').run(),
                vm_1["default"]('compile').run(),
                images_1["default"]('compile').run(),
            ]).then(function () {
                log.success('静态文件全部打包完成');
            })["catch"](function (err) {
                log.error('打包错误\n');
                log.error(err.stack);
            });
            break;
        case 'js':
            js_1["default"]('', 'compile').run().then(function () {
                log.success('js打包完成');
            })["catch"](function (err) {
                log.error(err.stack);
                log.error('js打包错误');
            });
            break;
        case 'jslab':
            compileLab_1["default"]('compile').run().then(function () {
                log.success('js-lab打包完成');
            })["catch"](function (err) {
                log.error(err.stack);
                log.error('js-lab打包错误');
            });
            break;
        case 'css':
            css_1["default"]('', 'compile').run().then(function () {
                log.success('css打包完成');
            })["catch"](function (err) {
                log.error(err.stack);
            });
            break;
        case 'sass':
        case 'scss':
            scss_1["default"]('', 'compile').run().then(function () {
                log.success('scss打包完成');
            });
            break;
        case 'vm':
            vm_1["default"]('compile').run().then(function () {
                log.success('vm打包完成');
            })["catch"](function (err) {
                log.error(err);
            });
            break;
        case 'images':
        case 'image':
        case 'img':
        case 'png':
        case 'jpg':
            images_1["default"]('compile').run().then(function () {
                log.success('images打包完成');
            })["catch"](function (err) {
                log.error(err);
            });
        default:
            break;
    }
};
exports["default"] = run;
