"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
/**
 * 编译js/ts
 */
var fs = require("fs");
var path = require("path");
var babel_core_1 = require("babel-core");
var uglify_js_1 = require("uglify-js");
var CompileBaseClass_1 = require("../CompileBaseClass");
var getBabelConfig_1 = require("../dependencies/getBabelConfig");
var readDir_1 = require("../../../util/readDir");
var mkdirs_1 = require("../../../util/mkdirs");
var watch_1 = require("../../../util/watch");
var dophin_core_1 = require("dophin-core");
var log = dophin_core_1.utils.log;
var JsLabCompiler = /** @class */ (function (_super) {
    __extends(JsLabCompiler, _super);
    function JsLabCompiler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    JsLabCompiler.prototype.taskRunning = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, rootPath, rootConfig, _b, projectConfig, _c, entry, type, project, outDir, entryDir, handleJs, watchTask, asyncCompile;
            return __generator(this, function (_d) {
                _a = this.runtime, rootPath = _a.rootPath, rootConfig = _a.rootConfig, _b = _a.projectConfig, projectConfig = _b === void 0 ? {} : _b;
                _c = this.params, entry = _c.entry, type = _c.type;
                project = global.__PROJECT__;
                if (type === undefined) {
                    type = entry;
                }
                outDir = rootConfig && rootConfig.dist.js.replace('{project}', project) || '';
                entryDir = rootConfig && rootConfig.src.jsLab.replace('{project}', project) || '';
                if (!fs.existsSync(entryDir)) {
                    return [2 /*return*/];
                }
                handleJs = function (filepath) {
                    var fileBasename = path.basename(filepath);
                    var promise = new Promise(function (resolve, reject) {
                        if (filepath && fileBasename.indexOf('.') !== 0) {
                            var src_1 = filepath, _dir = path.relative(entryDir, src_1), dest_1 = path.resolve(outDir, _dir);
                            // 如果没有目标目录，则递归创建
                            mkdirs_1["default"](path.dirname(dest_1));
                            if (fs.existsSync(src_1)) {
                                log.debug("\u5F00\u59CB\u6253\u5305" + fileBasename);
                                fs.readFile(src_1, { encoding: 'utf8' }, function (err, codes) {
                                    if (err) {
                                        reject(err);
                                        return;
                                    }
                                    var _codes = codes;
                                    // 如果需要babel编译
                                    if (Array.isArray(projectConfig.jsLabBabel) && projectConfig.jsLabBabel.includes(path.basename(src_1))) {
                                        try {
                                            _codes = babel_core_1.transform(_codes, getBabelConfig_1.getBabelConfig()).code + '';
                                        }
                                        catch (error) {
                                            log.error(error.message);
                                        }
                                    }
                                    // 生产环境需要压缩代码
                                    if (process.env.NODE_ENV === 'production') {
                                        try {
                                            _codes = uglify_js_1.minify(_codes).code;
                                        }
                                        catch (error) {
                                            log.error(error.message);
                                        }
                                    }
                                    fs.writeFileSync(dest_1, _codes, 'utf8');
                                    resolve(fileBasename);
                                });
                            }
                            else {
                                reject(new Error(fileBasename + "\u4E0D\u5B58\u5728"));
                            }
                        }
                    });
                    return promise;
                };
                watchTask = function () {
                    // 监听项目目录所有文件修改
                    watch_1["default"]({ directories: [entryDir] }, function (filePath, mtime) {
                        if (!fs.existsSync(filePath)) {
                            log.warn(path.basename(filePath) + "\u5DF2\u5220\u9664, build\u76EE\u5F55\u5185\u5386\u53F2\u6253\u5305\u6587\u4EF6\u4ECD\u7136\u4FDD\u7559");
                            return;
                        }
                        handleJs(filePath)["catch"](function (err) {
                            log.error(err);
                        });
                    });
                };
                asyncCompile = function () {
                    var files = readDir_1["default"](entryDir);
                    var promises = files.map(function (file) {
                        return handleJs(file.path);
                    });
                    return Promise.all(promises);
                };
                switch (type) {
                    case 'watch':
                        watchTask();
                        break;
                    case 'compile':
                        return [2 /*return*/, asyncCompile()];
                    case 'watchAndCompile':
                        asyncCompile().then(function () {
                            log.success('js-lab打包完成');
                        })["catch"](function (err) {
                            log.error('js-lab打包错误');
                        });
                        watchTask();
                        break;
                    default:
                        return [2 /*return*/, asyncCompile()];
                }
                return [2 /*return*/];
            });
        });
    };
    return JsLabCompiler;
}(CompileBaseClass_1["default"]));
var wrapper = function (entry, type) {
    return new JsLabCompiler(entry, type);
};
exports["default"] = wrapper;
