"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
/**
 * 编译js/ts
 */
var fs = require("fs");
var path = require("path");
var webpack = require("webpack");
var extend = require("extend");
var CompileBaseClass_1 = require("../CompileBaseClass");
var getCompileConfig_1 = require("../dependencies/getCompileConfig");
var readDir_1 = require("../../../util/readDir");
var getJsEntryName_1 = require("../../../util/getJsEntryName");
var watch_1 = require("../../../util/watch");
var dophin_core_1 = require("dophin-core");
var log = dophin_core_1.utils.log;
var concat_1 = require("./tools/concat");
// 封装 webpack repl 日志方法
var webpackLog = function (err, stats) {
    if (err) {
        log.error(err.message);
        return;
    }
    console.log('webpack打包结果\n' + stats.toString({
        hash: false,
        chunks: false,
        colors: true,
        children: false,
        modules: false
    }));
};
var JsCompiler = /** @class */ (function (_super) {
    __extends(JsCompiler, _super);
    function JsCompiler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    JsCompiler.prototype.beforeTaskRun = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, rootPath, rootConfig, _c, projectConfig, _d, entry, type, project, entryDir, outDir, webpackEntry, keepOriginalFilename, files, outputFilename, outputChunkFilename, calculatConfig, compileConfig, webpackConfig, bundles, bundleDirInBuild, bundleConfigFilepath, bundleEntry, bundleConfig, _i, bundles_1, _b, _bundleRawName, _bundleFullName, bundleWebpackConfig, compiler_1, compilePromise, _e, bundleConfigContent;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        _a = this.runtime, rootPath = _a.rootPath, rootConfig = _a.rootConfig, _c = _a.projectConfig, projectConfig = _c === void 0 ? {} : _c;
                        _d = this.params, entry = _d.entry, type = _d.type;
                        project = global.__PROJECT__;
                        entryDir = rootConfig && rootConfig.src.js.replace('{project}', project) || '';
                        outDir = rootConfig && rootConfig.dist.js.replace('{project}', project);
                        webpackEntry = {};
                        keepOriginalFilename = projectConfig.keepOriginalFilename;
                        if (entry) {
                            webpackEntry[getJsEntryName_1["default"](entry, keepOriginalFilename)] = entry;
                        }
                        else {
                            if (!fs.existsSync(entryDir)) {
                                return [2 /*return*/];
                            }
                            files = readDir_1["default"](entryDir);
                            files.forEach(function (file) {
                                if (file.name.indexOf('entry') === 0) {
                                    var relPath = path.relative(entryDir, path.dirname(file.path));
                                    webpackEntry[(relPath ? relPath + "/" : '') + getJsEntryName_1["default"](file.name, keepOriginalFilename)] = file.path;
                                }
                            });
                        }
                        outputFilename = '[name].js';
                        outputChunkFilename = '[name].js';
                        // 仅生产环境才给chunk文件名添加哈希值
                        if (projectConfig.version && process.env.NODE_ENV === 'production') {
                            outputChunkFilename = '[name].[chunkhash:5].js';
                        }
                        calculatConfig = {
                            entry: webpackEntry,
                            output: {
                                path: outDir,
                                filename: outputFilename,
                                publicPath: "/" + project + "/js/",
                                chunkFilename: outputChunkFilename
                            }
                        };
                        return [4 /*yield*/, getCompileConfig_1["default"]({ rootPath: rootPath, rootConfig: rootConfig, projectConfig: projectConfig })];
                    case 1:
                        compileConfig = _f.sent();
                        webpackConfig = extend(true, calculatConfig, compileConfig.webpack);
                        // 存储webpack配置
                        this.webpackConfig = webpackConfig;
                        if (!projectConfig.bundle) return [3 /*break*/, 6];
                        bundles = projectConfig.bundle;
                        bundleDirInBuild = 'bundle';
                        bundleConfigFilepath = path.resolve(entryDir, 'bundle_config.js');
                        bundleEntry = {};
                        bundleConfig = {};
                        for (_i = 0, bundles_1 = bundles; _i < bundles_1.length; _i++) {
                            _b = bundles_1[_i];
                            _bundleRawName = getJsEntryName_1["default"](path.basename(_b.entry));
                            _bundleFullName = _bundleRawName;
                            if (_b.version) {
                                _bundleFullName += "_" + String(_b.version).replace(/\./g, '_');
                            }
                            bundleEntry[_bundleFullName] = _b.entry;
                            bundleConfig[_bundleRawName] = bundleDirInBuild + "/" + _bundleFullName + ".js";
                        }
                        bundleWebpackConfig = extend(false, {}, webpackConfig, {
                            entry: bundleEntry, output: {
                                path: path.join(outDir || '', bundleDirInBuild)
                            }
                        });
                        compiler_1 = webpack(bundleWebpackConfig);
                        compilePromise = function () {
                            return new Promise(function (resolve, reject) {
                                compiler_1.run(function (_err, stats) {
                                    webpackLog(_err, stats);
                                    if (_err) {
                                        reject(_err);
                                        return;
                                    }
                                    resolve();
                                });
                            });
                        };
                        _e = type;
                        switch (_e) {
                            case 'watch': return [3 /*break*/, 2];
                            case 'watchAndCompile': return [3 /*break*/, 2];
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        compiler_1.watch({}, function (err, stats) {
                            webpackLog(err, stats);
                        });
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, compilePromise()];
                    case 4:
                        _f.sent();
                        _f.label = 5;
                    case 5:
                        bundleConfigContent = "/**\n * bundle\u914D\u7F6E\n * @version " + new Date() + "\n */\n\nmodule.export = " + JSON.stringify(bundleConfig) + ";\n";
                        fs.writeFileSync(bundleConfigFilepath, bundleConfigContent, { encoding: 'utf8' });
                        _f.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    JsCompiler.prototype.taskRunning = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, projectConfig, _c, entry, type, concatConfig, isConcatFiles, compiler, compilePromise, concatPromise, watchAndConcat, hasEntryFile, compilePromises;
            return __generator(this, function (_d) {
                _a = this.runtime.projectConfig, projectConfig = _a === void 0 ? {} : _a;
                _c = this.params, entry = _c.entry, type = _c.type;
                concatConfig = projectConfig.jsConcat;
                isConcatFiles = concatConfig ? true : false;
                compiler = webpack(this.webpackConfig);
                compilePromise = function () {
                    return new Promise(function (resolve, reject) {
                        compiler.run(function (_err, stats) {
                            webpackLog(_err, stats);
                            if (_err) {
                                reject(_err);
                                return;
                            }
                            resolve();
                        });
                    });
                };
                concatPromise = function () {
                    var promises = [];
                    Array.isArray(concatConfig) && concatConfig.forEach(function (task) {
                        promises.push(concat_1["default"](task.target, task.source));
                    });
                    return Promise.all(promises);
                };
                watchAndConcat = function () {
                    var watchTask = {};
                    Array.isArray(concatConfig) && concatConfig.forEach(function (task) {
                        task.source.forEach(function (sourceFile) {
                            if (watchTask[sourceFile]) {
                                watchTask[sourceFile].push(task);
                            }
                            else {
                                watchTask[sourceFile] = [task];
                            }
                        });
                    });
                    var _loop_1 = function (sourceFile) {
                        watch_1["default"]({
                            files: [sourceFile]
                        }, function (filePath, mtime) {
                            watchTask[sourceFile].forEach(function (task) {
                                concat_1["default"](task.target, task.source);
                            });
                        });
                    };
                    for (var sourceFile in watchTask) {
                        _loop_1(sourceFile);
                    }
                };
                hasEntryFile = !!entry || Object.keys(this.webpackConfig.entry || {}).length > 0;
                // 如果找不到以 entry 开头的 js 文件, 则将所有 js 文件 (不以下划线'_'开头) 作为入口文件
                // if (!hasEntryFile) {
                //     log.warn('找不到以entry开头的js文件, 所有js文件都将作为入口(不以下划线"_"开头)');
                //     const entryDir: string = rootConfig && rootConfig.src.js.replace('{project}', project) || '';
                //     const files = readFilesRecur(entryDir);
                //     files.forEach((file) => {
                //         if (file.name.indexOf('_') !== 0) {
                //             webpackEntry[getName(file.name, keepOriginalFilename)] = file.path;
                //         }
                //     });
                // }
                switch (type) {
                    case 'watch':
                    case 'watchAndCompile':
                        isConcatFiles && watchAndConcat();
                        hasEntryFile && compiler.watch({}, function (err, stats) {
                            webpackLog(err, stats);
                        });
                        break;
                    default:
                        compilePromises = [];
                        isConcatFiles && compilePromises.push(concatPromise());
                        hasEntryFile && compilePromises.push(compilePromise());
                        return [2 /*return*/, Promise.all(compilePromises)];
                }
                return [2 /*return*/];
            });
        });
    };
    return JsCompiler;
}(CompileBaseClass_1["default"]));
var wrapper = function (entry, type) {
    return new JsCompiler(entry, type);
};
exports["default"] = wrapper;
