"use strict";
/**
 * 编译sass 调用系统compass
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var fs = require("fs");
var path = require("path");
var rimraf = require("rimraf");
var postcss = require("postcss");
var compass_1 = require("./tools/compass");
var sass_1 = require("./tools/sass");
var css_1 = require("../css");
var CompileBaseClass_1 = require("../CompileBaseClass");
var getPostcssPlugins_1 = require("../dependencies/getPostcssPlugins");
var mkdirs_1 = require("../../../util/mkdirs");
var readDir_1 = require("../../../util/readDir");
var dophin_core_1 = require("dophin-core");
var log = dophin_core_1.utils.log, debounce = dophin_core_1.utils.debounce;
var SassCompiler = /** @class */ (function (_super) {
    __extends(SassCompiler, _super);
    function SassCompiler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SassCompiler.prototype.taskRunning = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var _a, rootPath, rootConfig, _b, projectConfig, _c, entry, type, getString, project, outDir, entryDir, sassCompileSingleFile, asyncCompile, watchTask, compileTask;
            return __generator(this, function (_d) {
                _a = this.runtime, rootPath = _a.rootPath, rootConfig = _a.rootConfig, _b = _a.projectConfig, projectConfig = _b === void 0 ? {} : _b;
                _c = this.params, entry = _c.entry, type = _c.type, getString = _c.getString;
                project = global.__PROJECT__;
                outDir = rootConfig && rootConfig.dist.css.replace('{project}', project) || '';
                entryDir = rootConfig && rootConfig.src.scss.replace('{project}', project) || '';
                if (!fs.existsSync(entryDir)) {
                    return [2 /*return*/];
                }
                sassCompileSingleFile = function (file) { return __awaiter(_this, void 0, void 0, function () {
                    var src, _dir, dest, postcssPlugins, css, usePostcss;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                src = file, _dir = path.relative(entryDir, src);
                                dest = path.resolve(outDir, _dir);
                                dest = dest.replace(path.extname(dest), '.css');
                                // 创建目录
                                mkdirs_1["default"](path.dirname(dest));
                                postcssPlugins = getPostcssPlugins_1["default"]({ rootPath: rootPath, rootConfig: rootConfig, projectConfig: projectConfig }, file);
                                log.info("sass: \u4F7F\u7528node-sass\u6253\u5305 " + path.basename(file) + " \u4E2D...");
                                return [4 /*yield*/, sass_1["default"](file)];
                            case 1:
                                css = _a.sent();
                                log.info("sass: \u4F7F\u7528postcss\u5904\u7406 " + path.basename(file) + " ");
                                usePostcss = new Promise(function (resolve, reject) {
                                    postcss(postcssPlugins).process(css, {
                                        from: file,
                                        to: dest
                                    }).then(function (result) {
                                        if (!getString) {
                                            fs.writeFileSync(dest, result.css, 'utf8');
                                        }
                                        resolve(result.css);
                                    })["catch"](function (error) {
                                        reject(error);
                                    });
                                });
                                return [4 /*yield*/, usePostcss];
                            case 2: return [2 /*return*/, _a.sent()];
                        }
                    });
                }); };
                asyncCompile = function (filepath) { return __awaiter(_this, void 0, void 0, function () {
                    var _this = this;
                    var compassPromises, sassPromises;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!(projectConfig.sass && projectConfig.sass && projectConfig.sass.compass && projectConfig.sass.compass.need)) return [3 /*break*/, 2];
                                log.info('sass: compass打包中...');
                                return [4 /*yield*/, compass_1["default"]({
                                        css: outDir,
                                        sass: entryDir,
                                        project: rootPath || process.cwd()
                                    })];
                            case 1:
                                _a.sent();
                                // 打包后使用postcss处理
                                log.info('sass: 使用postcss处理compass打包后文件们');
                                compassPromises = readDir_1["default"](outDir).map((function (file) { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        return [2 /*return*/, css_1["default"](file.path, 'compile', false, { src: file.path, dest: file.path }).run()];
                                    });
                                }); }));
                                return [2 /*return*/, Promise.all(compassPromises)];
                            case 2:
                                sassPromises = readDir_1["default"](entryDir).map((function (file) { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                if (path.basename(file.path).indexOf('_') === 0) {
                                                    return [2 /*return*/];
                                                }
                                                return [4 /*yield*/, sassCompileSingleFile(file.path)];
                                            case 1: return [2 /*return*/, _a.sent()];
                                        }
                                    });
                                }); }));
                                return [2 /*return*/, Promise.all(sassPromises)];
                        }
                    });
                }); };
                watchTask = function () {
                    if (!projectConfig.sass) {
                        return;
                    }
                    // 监听项目目录所有文件修改
                    fs.watch(entryDir, {
                        encoding: 'utf8',
                        recursive: true,
                        persistent: true
                    }, debounce(function (eventType) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, asyncCompile()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); }, 100));
                };
                compileTask = function () {
                    return new Promise(function (resolve, reject) {
                        if (entry) {
                            resolve(sassCompileSingleFile(entry));
                            return;
                        }
                        if (!projectConfig.sass) {
                            resolve('');
                        }
                        else {
                            log.debug("\u5F00\u59CB\u6E05\u7406" + outDir);
                            rimraf(outDir, function (err) {
                                if (err) {
                                    log.error(err.message);
                                    reject(err);
                                    return;
                                }
                                resolve(asyncCompile());
                            });
                        }
                    });
                };
                switch (type) {
                    case 'watch':
                        watchTask();
                        break;
                    case 'compile':
                        return [2 /*return*/, compileTask()];
                    case 'watchAndCompile':
                        compileTask().then();
                        watchTask();
                        break;
                    default:
                        return [2 /*return*/, compileTask()];
                }
                return [2 /*return*/];
            });
        });
    };
    SassCompiler.prototype.afterTaskRun = function () {
        var _a = this.params.entry, entry = _a === void 0 ? '' : _a;
        // 将运行结果记录到result
        this.result = this.runtime.taskRunning;
    };
    return SassCompiler;
}(CompileBaseClass_1["default"]));
var wrapper = function (entry, type, getString) {
    return new SassCompiler(entry, type, getString);
};
exports["default"] = wrapper;
