"use strict";
/**
 * 利用compass全局命令封装
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var path = require("path");
var child_process_1 = require("child_process");
var which_1 = require("which");
var log_1 = require("../../../../util/log");
var compass = function (options) { return __awaiter(_this, void 0, void 0, function () {
    var defaults, compassCommand, optionsArr, promise;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                defaults = {
                    style: false,
                    comments: false,
                    relative: true,
                    css: 'css',
                    sass: 'sass',
                    image: false,
                    generated_images_path: false,
                    http_path: false,
                    javascript: false,
                    font: false,
                    import_path: false,
                    config_file: false,
                    require: false,
                    logging: true,
                    load_all: false,
                    project: process.cwd(),
                    bundle_exec: false,
                    debug: false,
                    time: false,
                    sourcemap: false,
                    boring: false,
                    force: false,
                    task: 'compile'
                };
                options = Object.assign(defaults, options);
                compassCommand = 'compass';
                try {
                    compassCommand = which_1.sync(compassCommand);
                }
                catch (err) {
                    return [2 /*return*/, new Error('请安装sass和compass')];
                }
                optionsArr = [];
                // set compass setting
                optionsArr.push('compile');
                if (process.platform === 'win32') {
                    optionsArr.push(options.project.replace(/\\/g, '/'));
                }
                else {
                    optionsArr.push(options.project);
                }
                if (options.debug) {
                    optionsArr.push('--debug-info');
                }
                if (options.time) {
                    optionsArr.push('--time');
                }
                if (options.boring) {
                    optionsArr.push('--boring');
                }
                if (options.sourcemap) {
                    optionsArr.push('--sourcemap');
                }
                if (options.style) {
                    optionsArr.push('--output-style', options.style);
                }
                optionsArr.push('--css-dir', path.normalize(options.css));
                optionsArr.push('--sass-dir', path.normalize(options.sass));
                promise = new Promise(function (resolve, reject) {
                    var child = child_process_1.spawn(compassCommand, optionsArr, { cwd: options.project || process.cwd() });
                    var stdout = '', stderr = '';
                    if (options.logging) {
                        child.stdout.setEncoding('utf8');
                        child.stdout.on('data', function (data) {
                            stdout += data;
                            log_1["default"].debug(data.toString());
                        });
                        child.stderr.setEncoding('utf8');
                        child.stderr.on('data', function (data) {
                            stderr += data;
                            if (!data.toString().match(/^\u001b\[\d+m$/)) {
                                log_1["default"].error(data.toString());
                            }
                        });
                    }
                    child.on('close', function (code) {
                        resolve(stdout);
                    });
                });
                return [4 /*yield*/, promise];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports["default"] = compass;
