"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
/**
 * 编译vm
 */
var fs = require("fs");
var path = require("path");
var rimraf = require("rimraf");
var CompileBaseClass_1 = require("../CompileBaseClass");
var readDir_1 = require("../../../util/readDir");
var mkdirs_1 = require("../../../util/mkdirs");
var watch_1 = require("../../../util/watch");
var dophin_core_1 = require("dophin-core");
var log = dophin_core_1.utils.log;
var VelocityCompiler = /** @class */ (function (_super) {
    __extends(VelocityCompiler, _super);
    function VelocityCompiler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VelocityCompiler.prototype.taskRunning = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, rootPath, rootConfig, _b, projectConfig, _c, entry, type, project, outDir, entryDir, handleVM, watchTask, asyncCompile, compilePromise;
            return __generator(this, function (_d) {
                _a = this.runtime, rootPath = _a.rootPath, rootConfig = _a.rootConfig, _b = _a.projectConfig, projectConfig = _b === void 0 ? {} : _b;
                _c = this.params, entry = _c.entry, type = _c.type;
                project = global.__PROJECT__;
                if (type === undefined) {
                    type = entry;
                }
                outDir = rootConfig && rootConfig.dist.vm.replace('{project}', project) || '';
                entryDir = rootConfig && rootConfig.src.vm.replace('{project}', project) || '';
                if (!fs.existsSync(entryDir)) {
                    return [2 /*return*/];
                }
                handleVM = function (filename) {
                    var promise = new Promise(function (resolve, reject) {
                        var fileBasename = path.basename(filename);
                        if (filename && fileBasename.indexOf('.') !== 0) {
                            var src = filename, _dir = path.relative(entryDir, src), dest = path.resolve(outDir, _dir);
                            mkdirs_1["default"](path.dirname(dest));
                            if (fs.existsSync(src)) {
                                log.debug("\u5F00\u59CB\u6253\u5305" + fileBasename);
                                var readStream = fs.createReadStream(src), writeStream = fs.createWriteStream(dest);
                                readStream.pipe(writeStream);
                                readStream.on('error', function (e) {
                                    reject(e);
                                });
                                readStream.on('end', function (e) {
                                    resolve(fileBasename);
                                });
                            }
                            else {
                                reject(new Error(fileBasename + "\u4E0D\u5B58\u5728"));
                            }
                        }
                    });
                    return promise;
                };
                watchTask = function () {
                    // 监听项目目录所有文件修改
                    watch_1["default"]({ directories: [entryDir] }, function (filePath, mtime) {
                        handleVM(filePath)["catch"](function (err) {
                            log.error(err);
                        });
                    });
                };
                asyncCompile = function () {
                    var files = readDir_1["default"](entryDir);
                    var promises = files.map(function (file) {
                        return handleVM(file.path);
                    });
                    return Promise.all(promises);
                };
                compilePromise = function () {
                    return new Promise(function (resolve, reject) {
                        log.debug("\u5F00\u59CB\u6E05\u7406" + outDir);
                        rimraf(outDir, function (err) {
                            if (err) {
                                reject(err);
                                return;
                            }
                            resolve(asyncCompile());
                        });
                    });
                };
                switch (type) {
                    case 'watch':
                        watchTask();
                        break;
                    case 'compile':
                        return [2 /*return*/, compilePromise()];
                    case 'watchAndCompile':
                        asyncCompile().then(function () {
                            log.success('vm打包完成');
                        })["catch"](function (_err) {
                            log.error(_err);
                        });
                        watchTask();
                        break;
                    default:
                        return [2 /*return*/, compilePromise()];
                }
                return [2 /*return*/];
            });
        });
    };
    return VelocityCompiler;
}(CompileBaseClass_1["default"]));
var wrapper = function (entry, type) {
    return new VelocityCompiler(entry, type);
};
exports["default"] = wrapper;
