"use strict";
/**
 * deploy类
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var dophin_core_1 = require("dophin-core");
var GetGitStatus_1 = require("./dependencies/GetGitStatus");
var GetDeployConfig_1 = require("./dependencies/GetDeployConfig");
var log_1 = require("../../util/log");
var DeployClass = /** @class */ (function (_super) {
    __extends(DeployClass, _super);
    function DeployClass(taskKey, common) {
        return _super.call(this, { taskKey: taskKey, common: common }) || this;
    }
    DeployClass.prototype.dophinInited = function () {
        var _a = this.runtime, allProjects = _a.allProjects, rootPath = _a.rootPath, rootConfig = _a.rootConfig;
        var _b = this.params, taskKey = _b.taskKey, common = _b.common;
        if (!rootConfig) {
            log_1["default"].error('获取项目根目录do.config.js配置文件出错');
            return false;
        }
        log_1["default"].info('开始初始化deploy配置信息');
        this.initDeployConfig(taskKey);
        if (!this.deployConfig) {
            log_1["default"].error("deploy." + taskKey + " \u914D\u7F6E\u9519\u8BEF, \u8BF7\u68C0\u67E5");
            return false;
        }
        // 设置项目名
        var project = global.__PROJECT__;
        if (!project) {
            log_1["default"].error('DeployClass 缺少参数 project');
            return false;
        }
        if (Array.isArray(allProjects) && !allProjects.includes(project)) {
            log_1["default"].error(rootPath + " \u4E0B\u627E\u4E0D\u5230\u5B50\u9879\u76EE " + project);
        }
        log_1["default"].info('开始初始化开发环境git信息');
        this.initGit();
    };
    /**
     * 初始化git信息
     */
    DeployClass.prototype.initGit = function () {
        this.git = GetGitStatus_1["default"]();
    };
    /**
     * 初始化deploy配置
     */
    DeployClass.prototype.initDeployConfig = function (taskKey) {
        var _a = this.runtime, rootConfig = _a.rootConfig, _b = _a.rootPath, rootPath = _b === void 0 ? '' : _b;
        var deployConfig = GetDeployConfig_1["default"](taskKey, rootPath, rootConfig);
        if (deployConfig) {
            this.deployConfig = deployConfig;
        }
        else {
            log_1["default"].error('初始化deploy配置信息失败');
        }
    };
    return DeployClass;
}(dophin_core_1.DophinBaseClass));
exports["default"] = DeployClass;
