"use strict";
exports.__esModule = true;
/**
 * 按照配置打包所有静态文件
 */
var scss_1 = require("../compile/scss");
var js_1 = require("../compile/js");
var compileLab_1 = require("../compile/js/compileLab");
var css_1 = require("../compile/css");
var vm_1 = require("../compile/vm");
var images_1 = require("../compile/images");
var compile = function (projectConfig, config) {
    var compileTasks = [];
    config && config.CONFIG.type.forEach(function (type) {
        switch (type) {
            case 'js':
                compileTasks.push(js_1["default"]('', 'compile').run());
                compileTasks.push(compileLab_1["default"]('compile').run());
                break;
            case 'css':
                compileTasks.push(css_1["default"]('', 'compile').run());
                if (projectConfig.sass) {
                    compileTasks.push(scss_1["default"]('', 'compile').run());
                }
                break;
            case 'images':
                compileTasks.push(images_1["default"]('compile').run());
                break;
            case 'vm':
                compileTasks.push(vm_1["default"]('compile').run());
                break;
            default:
                break;
        }
    });
    return Promise.all(compileTasks);
};
exports["default"] = compile;
