"use strict";
/**
 * 文件校验
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var fs = require("fs");
var crypto = require("crypto");
var log_1 = require("../../../../util/log");
var computeHash = function (filename, algo) {
    var chksum = crypto.createHash(algo);
    var promise = new Promise(function (resolve, reject) {
        var s;
        if (fs.existsSync(filename)) {
            s = fs.createReadStream(filename);
            s.on('error', function (err) {
                reject(err);
            });
            s.on('data', function (d) {
                chksum.update(d);
            });
            s.on('end', function () {
                var d = chksum.digest('hex');
                resolve(d);
            });
        }
        else {
            chksum.update(filename);
            var d = chksum.digest('hex');
            resolve(d);
        }
    });
    return promise;
};
var compare = function (file1, file2, algo) {
    if (algo === void 0) { algo = 'sha1'; }
    return __awaiter(_this, void 0, void 0, function () {
        var file1hash, file2hash, _file1, _file2, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    return [4 /*yield*/, computeHash(file1, algo)];
                case 1:
                    file1hash = _a.sent();
                    return [4 /*yield*/, computeHash(file2, algo)];
                case 2:
                    file2hash = _a.sent();
                    if (file1hash === file2hash) {
                        return [2 /*return*/, true];
                    }
                    else {
                        _file1 = file1, _file2 = file2;
                        if (fs.existsSync(file1)) {
                            _file1 = fs.readFileSync(file1, 'utf8');
                        }
                        if (fs.existsSync(file2)) {
                            _file2 = fs.readFileSync(file2, 'utf8');
                        }
                        return [2 /*return*/, _file1 === _file2];
                    }
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    log_1["default"].error(error_1.message);
                    return [2 /*return*/, false];
                case 4: return [2 /*return*/];
            }
        });
    });
};
exports["default"] = compare;
