"use strict";
/**
 * 正式开始deploy前处理方法
 */
exports.__esModule = true;
var path = require("path");
var rimraf = require("rimraf");
var JsHandle_1 = require("./tasks/JsHandle");
var readDir_1 = require("../../../util/readDir");
var log_1 = require("../../../util/log");
var preCompile = function (rootConfig, config) {
    var project = global.__PROJECT__;
    // 获取出口
    var outDir = rootConfig && rootConfig.dist.src.replace('{project}', project) || '';
    // 构建前处理js
    var promise = new Promise(function (resolve, reject) {
        log_1["default"].debug("\u5F00\u59CB\u6E05\u7406" + outDir);
        // 构建前清理build文件夹
        rimraf(outDir, function (err) {
            if (err) {
                reject(err);
                return;
            }
            if (config && typeof config.jsHandle === 'function') {
                log_1["default"].debug('进行 jsHandle 预处理');
                var files = readDir_1["default"](path.resolve(config.source, 'js'));
                var promises = files.map(function (file) {
                    return JsHandle_1["default"](file.path, config.jsHandle);
                });
                resolve(Promise.all(promises));
            }
            else {
                resolve();
            }
        });
    });
    return promise;
};
exports["default"] = preCompile;
