"use strict";
/**
 * js预处理
 */
exports.__esModule = true;
var fs = require("fs");
var path = require("path");
var jsHandle = function (file, handle) {
    var promise = new Promise(function (resolve, reject) {
        var fileBasename = path.basename(file);
        fs.readFile(file, 'utf8', function (err, data) {
            if (err) {
                reject(err);
                return;
            }
            var newData = handle && handle(data) || data;
            if (newData) {
                fs.writeFile(file, newData, 'utf8', function (_err) {
                    if (_err) {
                        reject(_err);
                        return;
                    }
                    resolve();
                });
            }
        });
    });
    return promise;
};
exports["default"] = jsHandle;
