"use strict";
exports.__esModule = true;
var fs = require("fs");
var path = require("path");
var stylelint = require("stylelint");
var log_1 = require("../../util/log");
var format = function (filepath, rootDir) {
    if (rootDir === void 0) { rootDir = ''; }
    var configFile = path.resolve(rootDir, '.stylelintrc');
    if (!fs.existsSync(configFile)) {
        log_1["default"].error(rootDir + " \u4E0B\u627E\u4E0D\u5230 stylelint \u914D\u7F6E\u6587\u4EF6(.stylelintrc)");
        return;
    }
    if (fs.existsSync(filepath)) {
        stylelint.lint({
            files: filepath,
            configBasedir: path.resolve(__dirname, '../../'),
            configFile: configFile,
            fix: true,
            formatter: 'string'
        }).then(function (resultObject) {
            log_1["default"].success(path.basename(filepath) + " \u683C\u5F0F\u5316\u7ED3\u675F");
            if (resultObject.errored) {
                console.log(resultObject.output);
            }
        })["catch"](function (err) {
            log_1["default"].error(err.message);
        });
    }
    else {
        log_1["default"].error("\u627E\u4E0D\u5230\u6587\u4EF6: " + filepath);
    }
};
exports["default"] = format;
