"use strict";
exports.__esModule = true;
var fs = require("fs");
var path = require("path");
var download = require("download-git-repo");
var dophin_core_1 = require("dophin-core");
var log_1 = require("../../util/log");
var initProject = function (project) {
    var successLog = function () {
        log_1["default"].success("\u9879\u76EE " + project + " \u521B\u5EFA\u6210\u529F");
    };
    var dest = path.resolve(process.cwd(), project);
    if (fs.existsSync(dest)) {
        log_1["default"].error("\u5F53\u524D\u76EE\u5F55\u4E0B\u5DF2\u5B58\u5728 " + project + " \u76EE\u5F55");
        return;
    }
    download(dophin_core_1.constants.defaulteTemplateRepo[0], dest, function (err) {
        if (err) {
            download(dophin_core_1.constants.defaulteTemplateRepo[1], dest, { clone: true }, function (_err) {
                if (_err) {
                    log_1["default"].error("\u9879\u76EE " + project + " \u521B\u5EFA\u5931\u8D25, \u8054\u7CFB\u7BA1\u7406\u5458\u5427: " + err.message.trim());
                }
                else {
                    successLog();
                }
            });
        }
        else {
            successLog();
        }
    });
};
exports["default"] = initProject;
