"use strict";
/**
 * server base class
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var http = require("http");
var https = require("https");
var fs = require("fs");
var path = require("path");
var dophin_core_1 = require("dophin-core");
var initServer_1 = require("./initServer");
var compile_1 = require("../compile");
var log_1 = require("../../util/log");
var ServerBase = /** @class */ (function (_super) {
    __extends(ServerBase, _super);
    function ServerBase(port, enableSSL) {
        return _super.call(this, { port: port, enableSSL: enableSSL }) || this;
    }
    ServerBase.prototype.beforeTaskRun = function () {
        var _a = this.runtime.rootPath, rootPath = _a === void 0 ? '' : _a;
        // 如果项目路径包含build，则弹出警告
        if (rootPath.indexOf('build') !== -1) {
            log_1["default"].error("\u68C0\u6D4B\u5230\u9879\u76EE\u6839\u76EE\u5F55\u8DEF\u5F84" + rootPath + "\u5305\u542B'build'\uFF0C\u8FD9\u5C06\u5BFC\u81F4\u672C\u5730\u670D\u52A1\u5F02\u5E38\uFF0C\u8BF7\u7ACB\u5373\u4FEE\u6539\uFF01");
        }
    };
    ServerBase.prototype.taskRunning = function () {
        var project = global.__PROJECT__;
        var _a = this.runtime, rootConfig = _a.rootConfig, rootPath = _a.rootPath;
        var _b = this.params, port = _b.port, enableSSL = _b.enableSSL;
        // 监听并打包静态文件
        log_1["default"].success('开始编译并监听本地静态文件');
        compile_1["default"]('watchAll');
        // 启动本地服务
        var app = initServer_1["default"](rootConfig, rootPath);
        var onError = function (error) {
            if (error.syscall !== 'listen') {
                throw error;
            }
            switch (error.code) {
                case 'EACCES':
                    log_1["default"].error("\u76D1\u542C " + port + " \u7AEF\u53E3\u9700\u8981 root \u6743\u9650, \u5C1D\u8BD5 sudo \u91CD\u65B0\u8FD0\u884C");
                    process.exit(1);
                    break;
                case 'EADDRINUSE':
                    log_1["default"].error(port + " \u7AEF\u53E3\u88AB\u5360\u7528");
                    process.exit(2);
                    break;
                default:
                    throw error;
            }
        };
        var onListening = function () {
            log_1["default"].success("\u672C\u5730\u670D\u52A1\u5F00\u59CB\u8FD0\u884C, \u76D1\u542C\u7AEF\u53E3: " + port);
        };
        app.set('port', port);
        if (enableSSL) {
            port = 443;
            var sslOptions = {
                key: fs.readFileSync(path.resolve(__dirname, '../../ssl/private.key')),
                cert: fs.readFileSync(path.resolve(__dirname, '../../ssl/cert.pem'))
            };
            https.createServer(sslOptions, app).listen(port).on('error', onError).on('listening', onListening);
        }
        http.createServer(app).listen(port).on('error', onError).on('listening', onListening);
    };
    return ServerBase;
}(dophin_core_1.DophinBaseClass));
exports["default"] = ServerBase;
