"use strict";
/**
 * 找不到静态资源时，尝试自动补全子项目名
 */
exports.__esModule = true;
var fs = require("fs");
var path = require("path");
var url = require("url");
var mime = require("mime");
var mapStatic = function (project, rootPath) {
    var mock = function (req, res, next) {
        var fileUrlPath = url.parse(req.originalUrl).pathname + '';
        var filePath = path.resolve(rootPath, "project/" + project + "/build" + fileUrlPath);
        if (fs.existsSync(filePath)) {
            res.writeHead(200, {
                'Access-Control-Allow-Origin': '*',
                'Content-Type': mime.getType(filePath) || '',
                'Cache-Control': 'max-age=0',
                'Server': 'dophin',
                'X-Powered-By': 'dophin'
            });
            res.end(fs.readFileSync(filePath));
        }
        else {
            next();
        }
    };
    return mock;
};
exports["default"] = mapStatic;
