"use strict";
/**
 * mock data文件夹
 */
exports.__esModule = true;
var fs = require("fs");
var path = require("path");
var url = require("url");
var mockMiddleware = function (rootPath) {
    var mock = function (req, res, next) {
        var dataPath = path.resolve(rootPath, "." + url.parse(req.originalUrl).pathname);
        // 支持不写json后缀
        if (!dataPath.includes('.json')) {
            dataPath += '.json';
        }
        if (fs.existsSync(dataPath)) {
            res.writeHead(200, {
                'Access-Control-Allow-Origin': '*',
                'Content-Type': 'application/json;charset=utf-8',
                'Cache-Control': 'max-age=0',
                'Server': 'dophin',
                'X-Powered-By': 'dophin'
            });
            res.end(fs.readFileSync(dataPath));
        }
        else {
            next();
        }
    };
    return mock;
};
exports["default"] = mockMiddleware;
