"use strict";
/**
 * 递归读取目录内所有文件
 */
exports.__esModule = true;
var fs = require("fs");
var path = require("path");
var readDir = function (dir) {
    var result = [];
    var readDirRecur = function (recurDir) {
        var files = fs.readdirSync(recurDir);
        files.forEach(function (file) {
            var _path = path.resolve(recurDir, file);
            if (fs.lstatSync(_path).isDirectory()) {
                readDirRecur(_path);
            }
            else if (file.indexOf('.') !== 0) {
                result.push({
                    name: file,
                    path: _path
                });
            }
        });
    };
    readDirRecur(dir);
    return result;
};
exports["default"] = readDir;
