"use strict";
/**
 * 文件及文件夹watch封装
 */
exports.__esModule = true;
var Watchpack = require("watchpack");
var Watch = function (
    /**
     * 监听的文件数组或者目录数组
     */
    watchFiles, 
    /**
     * Watchpack配置参数
     */
    options, 
    /**
     * 文件change回调函数
     */
    cb) {
    if (typeof options === 'function') {
        cb = options;
        options = {};
    }
    var wp = new Watchpack(Object.assign({ poll: true }, options || {}));
    wp.watch(watchFiles.files || [], watchFiles.directories || [], Date.now() - 10000);
    wp.on("change", function (filePath, mtime) {
        cb && cb(filePath, mtime);
    });
};
exports["default"] = Watch;
