"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
const log_1 = require("./log");
let latestVersion = '';
try {
    child_process_1.exec('npm view dophin version', {
        encoding: 'utf8',
    }, (error, stdout, stderr) => {
        if (error || stderr) {
            log_1.default.error(`exec error: ${error || stderr}`);
            return;
        }
        latestVersion = stdout;
    });
}
catch (error) {
    log_1.default.debug(error.message);
}
const getVersion = () => latestVersion;
exports.default = getVersion;
