"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const readDir = (dir) => {
    const result = [];
    const readDirRecur = (recurDir) => {
        const files = fs.readdirSync(recurDir);
        files.forEach((file) => {
            const _path = path.resolve(recurDir, file);
            if (fs.lstatSync(_path).isDirectory()) {
                readDirRecur(_path);
            }
            else if (file.indexOf('.') !== 0) {
                result.push({
                    name: file,
                    path: _path,
                });
            }
        });
    };
    readDirRecur(dir);
    return result;
};
exports.default = readDir;
