"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Watchpack = require("watchpack");
const Watch = (watchFiles, options, cb) => {
    if (typeof options === 'function') {
        cb = options;
        options = {};
    }
    const wp = new Watchpack(Object.assign({ poll: true }, options || {}));
    wp.watch(watchFiles.files || [], watchFiles.directories || [], Date.now() - 10000);
    wp.on("change", (filePath, mtime) => {
        cb && cb(filePath, mtime);
    });
};
exports.default = Watch;
